Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 4.1.0   

Description

What this patch does:

1. It moves the sidebar to be rendered after the content block in base.html.erb, since natural flow of HTML should be from left to

right, so no point in rendering sidebar before the content block, because it doesn't match our base layout.

2. It sets the #main block to a flexbox and removes a redundant background color definition rule from it.

3. It changes the % based width of the sidebar to a fixed 220px (if you think it should be wider, feedback is welcome), because on

wide screens 22% is quite a lot of space!

4. #content block is the only one that will stretch now.

Related issues:

Related to Redmine - Patch #32037: Constrain sidebar width on different resol... Closed

Associated revisions

Revision 18033 - 2019-04-03 01:24 - Go MAEDA

Replace float rules with flexbox for content and sidebar block (#30435).

Patch by Max Johansson and Marius BALTEANU.

Revision 18135 - 2019-05-08 10:12 - Go MAEDA

Fix layout problem when showing wide tables (#30435).

Patch by Marius BALTEANU.

History

#1 - 2019-01-15 18:51 - Marius BĂLTEANU

- Subject changed from Change #main block to a flexbox + additional minor fixer to it's direct children. to Change #main block to a flexbox + additional

minor fixes to it's direct children.

#2 - 2019-01-16 10:11 - Go MAEDA

- Target version set to 4.1.0

It looks nice. Setting the target version to 4.1.0.

#3 - 2019-01-16 10:17 - Marius BĂLTEANU

Please do not commit because I want to test more these changes. I looked yesterday for few seconds and I saw some problems.

#4 - 2019-01-16 10:24 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

#5 - 2019-01-16 10:24 - Bernhard Rohloff

The patch looks good to me, although I'm not sure if the width is sufficient for the text length of everbody's saved queries. It also wraps the heading of

"Custom queries" if you choose German ( it's "Benutzerdefinierte Abfragen" ) as interface language. No big deal to me but I think it's worth

mentioning.

Overall, I think the patch is a great improvement.

+1
#6 - 2019-01-16 10:30 - Anonymous

I'm also wondering about the nature of this rule, does anybody have idea what it should do?

* html #content{ width: 75%; padding-left: 0; margin-top: 0px; padding: 6px 10px 10px 10px;}

 because in the default version, just one line above it would already be defined as:

#content{ width: 75%; padding-left: 0; margin-top: 0px; padding: 6px 10px 10px 10px;}

 I have a feeling, Internet Explorer is guilty :)

#7 - 2019-01-17 00:46 - Marius BĂLTEANU

In my environment, the #content loads first with 100% width and right after, the sidebar which makes the screen "shakes".

#8 - 2019-01-17 07:46 - Anonymous

- File main-block-fixes-no-swap.diff added

Marius BALTEANU wrote:

In my environment, the #content loads first with 100% width and right after, the sidebar which makes the screen "shake".

 Marius, I looked into it, so I'm attaching alternative patch without element swapping in base.html.erb to see if this one will not spawn shaking, the

previous patch must be reverted before applying this one.

The alternative method could as well be to set #main a flow-direction: row; instead of row-reverse and than add order: 1; for the #content and 

order: 2; for the #sidebar, but I guess this isn't needed now, because we only have 2 containers, but it could be useful if we re to spawn an additional

tile under the sidebar in the future for instance, else in the favor of less rules, it is imho just be simpler to reverse it. :)

#9 - 2019-01-17 21:36 - Marius BĂLTEANU

- File sidebar.png added

Thanks Max for updating the patch, it works well with row-reverse.

I agree with Bernhard, the sidebar width (220px) is too small even for small screens, please see the below screenshot from my 13 inch screen:

1. width: 220px;

 sidebar.png 

What do you think if we keep the existing width: 22% rule and we add a max-width of 280px or 300px?

#10 - 2019-01-18 10:08 - Anonymous

I think width: 22% will anyway often exceed it's maximum limitation of max-width, maybe we could try min-width: 220px and max-width: 280px or

300px?

In theory sidebar's content should then expand the sidebar in width within these margins a bit depending on what it contains. :)

#11 - 2019-01-20 14:34 - Anonymous

There is a gridbox design suggestion now pending for further discussion, so this ticket will be affected if we will decide to move #main-menu inside

#main container, ultimately making this patch obsolete, because it will then become a 3 tiled gridbox instead of a flexbox. Please see #30451#note-6

for reference.

#12 - 2019-01-21 07:25 - Marius BĂLTEANU

- Assignee deleted (Marius BĂLTEANU)

#13 - 2019-02-09 00:41 - Anonymous

- File main-block-fixes-no-swap-min-max.diff added

I think it will be better to ignore #30451 for now, so attaching the patch with min-width and max-width rules for the sidebar, the content of the sidebar

will now expand it up to 340px if contains long elements, if there is no need, it will reduce up to 220px. I think it's the most suitable resolution for

everyone.

I also removed some redundant rules this time, like:

* html #sidebar{ width: 22%; }

* html #content{ width: 75%; padding-left: 0; margin-top: 0px; padding: 6px 10px 10px 10px;}
#14 - 2019-02-14 11:28 - Go MAEDA

Max Johansson wrote:

I think it will be better to ignore #30451 for now, so attaching the patch with min-width and max-width rules for the sidebar, the content of the

sidebar will now expand it up to 340px if contains long elements, if there is no need, it will reduce up to 220px.

 Thank you for the patch. Narrower sidebar than the current implementation should be nice for many people.

I tried the patch but I found that the sidebar hardly expands even if there is a custom query with a long name and the width of the browser window is

around 1800px. With my Firefox, the width of the sidebar is 261px at 1024px window and 271px at 1800px window.

How can I see a sidebar with a width of 340px?

#15 - 2019-02-14 18:29 - Bernhard Rohloff

- File main-block-fixes-no-swap-min-max_no_shrink.diff added

Go MAEDA wrote:

I tried the patch but I found that the sidebar hardly expands even if there is a custom query with a long name and the width of the browser

window is around 1800px. With my Firefox, the width of the sidebar is 261px at 1024px window and 271px at 1800px window.

How can I see a sidebar with a width of 340px?

 I can confirm the behavior you described. I think is an issue with the flexbox constraints.

Here is a modified version of Max's patch which prevents the sidebar from shrinking. Can you check if it's working now?

#16 - 2019-02-25 07:28 - Go MAEDA

- File 30435-screenshot-20190225.png added

I tested main-block-fixes-no-swap-min-max_no_shrink.diff.

When there is a query with a long name, the sidebar became too large even in small screens and the left side of the page is cropped.

 

#17 - 2019-02-25 09:12 - Marius BĂLTEANU

Go MAEDA wrote:

I tested main-block-fixes-no-swap-min-max_no_shrink.diff.

When there is a query with a long name, the sidebar became too large even in small screens and the left side of the page is cropped.

 It is because of the missing width: 22%; rule.

#18 - 2019-02-25 10:50 - Bernhard Rohloff

The patch sets a min-width of 220px and a max-width of 340px for longer query names as it was constrained by Max in #30435#note-13.

By setting the width to 22% again we're loosing space on higher resolutions as the sidebar grows to its max-width even if there's no need to.
It can make a difference up to 120px which can give you an extra column in the issues list or an extra month on the gantt chart.

On the other hand I have to admit that 340px can be too big on small screens (37% @900px). It affects resolutions between 900px and around

1500px.

It just slightly affects the higher resolutions e.g. 1377px so should we consider to set the width only for smaller resolutions? What are your thoughts on

this?

#19 - 2019-02-26 00:42 - Anonymous

Bernhard Rohloff wrote:

By setting the width to 22% again we're loosing space on higher resolutions as the sidebar grows to its max-width even if there's no need to.

 What I tried to explain in #30435#note-10, but thanks for doing it more clearly. :)

On the other hand I have to admit that 340px can be too big on small screens (37% @900px). It affects resolutions between 900px and around

1500px.

It just slightly affects the higher resolutions e.g. 1377px so should we consider to set the width only for smaller resolutions? What are your

thoughts on this?

 I propose to either:

1. Create adaptive rules then where we d set max width of the sidebar for different screen sizes/resolutions like so:

Иван Савенко screen and (min-width: 1400px) {#sidebar{max-width:340px;}

Иван Савенко screen and (min-width: 1200px) {#sidebar{max-width:280px;}

Иван Савенко screen and (min-width: 1000px) {#sidebar{max-width:220px;}

I don't have different displays at the moment to test this, perhaps I'll have to do it with setting other lower resolutions of my 1920x1080 native display, I

will post an update when tests will be done then and post the patch.

2. Limit the length of the names of custom queries instead and then skip all the adaptive rules.

3. Or move queries away from the sidebar into a more lucky location and again skip all the adaptiveness, because frankly IMHO sidebar isn't the most

successful place for the menu objects which allow for ridiculously ultra-long titles.

#20 - 2019-02-27 11:05 - Bernhard Rohloff

Max Johansson wrote:

I propose to either:

1. Create adaptive rules then where we d set max width of the sidebar for different screen sizes/resolutions like so:

Иван Савенко screen and (min-width: 1400px) {#sidebar{max-width:340px;}

Иван Савенко screen and (min-width: 1200px) {#sidebar{max-width:280px;}

Иван Савенко screen and (min-width: 1000px) {#sidebar{max-width:220px;}

I don't have different displays at the moment to test this, perhaps I'll have to do it with setting other lower resolutions of my 1920x1080 native

display, I will post an update when tests will be done then and post the patch.

 Don't bother with fiddling around in your screen settings. You can test it easily with the builtin dev tools of you browser of choice. Nowadays they all

have an option to test multiple screen sizes.

This is IMHO my prefered solution.

2. Limit the length of the names of custom queries instead and then skip all the adaptive rules.

 I think this doesn't meet the requirements.

3. Or move queries away from the sidebar into a more lucky location and again skip all the adaptiveness, because frankly IMHO sidebar isn't the

most successful place for the menu objects which allow for ridiculously ultra-long titles.

 As im not a fan of the sidebar at all this would be my favorite solution. But it requires a lot more effort and discussion so I think this can't be an option

for this feature, right now.

#21 - 2019-03-27 23:50 - Marius BĂLTEANU

- File current.png added

- File after.png added

- File flex_for_content_and_sidebar.patch added

Let move the discussions about the sidebar width to another ticket and commit the other changes that replace the float rules with flex. In this way, we

fix an annoying bug on issue page that reproduces when the sidebar height is greater than the content height.
Current:

 current.png 

With the patch applied:

 after.png 

I'm attaching the patch that I would like to be committed, it contains the work done by Max and a small fix for the sidebar padding.

#22 - 2019-04-02 13:04 - Go MAEDA

- Subject changed from Change #main block to a flexbox + additional minor fixes to it's direct children. to Change #main block to a flexbox + additional

minor fixes to it's direct children

Marius BALTEANU wrote:

In this way, we fix an annoying bug on issue page that reproduces when the sidebar height is greater than the content height.

 Nice. I have been bothered by the bug for years.

#23 - 2019-04-03 01:25 - Go MAEDA

- Subject changed from Change #main block to a flexbox + additional minor fixes to it's direct children to Replace float rules with flexbox for content

and sidebar block

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the fix. Thank you for working on this.

#24 - 2019-04-28 12:47 - Go MAEDA

- File table-bug@2x.png added

- Status changed from Closed to Reopened

The change made in r18033 breaks the layout of some pages on medium-sized screens.

To reproduce the problem, open /users page in a 1024px wide browser. The left side of the table is cropped and you cannot see the first name

column.

 

#25 - 2019-04-28 22:41 - Marius BĂLTEANU

The below patch fixes the problem for me:

diff --git a/public/stylesheets/application.css b/public/stylesheets/application.css

index 09bcd5b..79cf1d0 100644

--- a/public/stylesheets/application.css

+++ b/public/stylesheets/application.css

@@ -92,7 +92,7 @@ pre, code {font-family: Consolas, Menlo, "Liberation Mono", Courier, monospace;}

 #sidebar div.wiki ul {margin:inherit; padding-left:40px;}

2025-05-02 5/7

https://www.redmine.org/projects/redmine/repository/svn/revisions/18033


 #sidebar div.wiki ul li {list-style-type:inherit;}

-#content { flex-grow: 1; background-color: #fff; margin: 0px; padding: 6px 10px 10px 10px; }

+#content { flex-grow: 1; background-color: #fff; margin: 0px; padding: 6px 10px 10px 10px; overflow-x: auto;}

 html>body #content { min-height: 600px; }

 * html body #content { height: 600px; } /* IE */

 Bernhard Ganslmeier, is it ok for you this fix?

#26 - 2019-05-08 06:34 - Yuichi HARADA

Marius BALTEANU wrote:

The below patch fixes the problem for me:

[...]

Bernhard Ganslmeier, is it ok for you this fix?

 Thank you for sharing the patch.

I confirmed that the layout on medium-sized screens( #30435#note-24, /issues and /time_entries pages) does not break by applying your patch.

#27 - 2019-05-08 09:56 - Bernhard Rohloff

I also tested the fix and it works for me, too.

#28 - 2019-05-08 10:13 - Go MAEDA

- Status changed from Reopened to Closed

Committed the fix submitted as #30435#note-25 in r18135. Thank you.

#29 - 2019-09-04 19:23 - Anonymous

- File responsive-multiresolution-sidebar.patch added

To conclude the major point behind this issue, which never got resolved back then, here is a patch to try out as a reference to #30435#note-19

#30 - 2019-09-05 02:19 - Go MAEDA

- Status changed from Closed to Reopened

#31 - 2019-09-08 11:49 - Go MAEDA

- Status changed from Reopened to Closed

Antonio McDeal wrote:

To conclude the major point behind this issue, which never got resolved back then, here is a patch to try out as a reference to #30435#note-19

 Thank you for posting the patch. I think the width of the sidebar should be discussed in another issue because the topic is really controversial as we

experienced in this issue and it will be difficult to close this issue for a long time. In my opinion, I don't like the sidebar width with the patch applied

because the width of the sidebar is wider than the current style at 1024px window width (I usually set the browser width to about 1000px - 1100px).

So, I close this issue. If anyone thinks the sidebar width should be improved with the approach suggested by the patch in #30435#note-29, please

open a new issue.

#32 - 2019-09-08 18:03 - Anonymous

I created a new issue #32037, please add it as related to this one, because part of important discussion was started in here. :)

#33 - 2019-09-09 02:32 - Go MAEDA

- Related to Patch #32037: Constrain sidebar width on different resolutions added

Files

main-block-fixes.diff 2.46 KB 2019-01-15 Anonymous

main-block-fixes-no-swap.diff 1.57 KB 2019-01-17 Anonymous

sidebar.png 289 KB 2019-01-17 Marius BĂLTEANU
main-block-fixes-no-swap-min-max.diff 1.67 KB 2019-02-08 Anonymous

main-block-fixes-no-swap-min-max_no_shrink.diff 1.68 KB 2019-02-14 Bernhard Rohloff

30435-screenshot-20190225.png 29.9 KB 2019-02-25 Go MAEDA

current.png 421 KB 2019-03-27 Marius BĂLTEANU

after.png 455 KB 2019-03-27 Marius BĂLTEANU

flex_for_content_and_sidebar.patch 1.8 KB 2019-03-27 Marius BĂLTEANU

table-bug@2x.png 79.7 KB 2019-04-28 Go MAEDA

responsive-multiresolution-sidebar.patch 1.12 KB 2019-09-04 Anonymous
